"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelLoaderConfig = babelLoaderConfig;
const supportedBrowserVersions = ['last 3 Chrome versions', 'last 3 Firefox versions', 'last 3 Edge versions', 'last 3 Safari versions'];

function babelLoaderConfig(options) {
  return {
    loader: 'babel-loader',
    options: {
      presets: [[require.resolve('@babel/preset-env'), {
        modules: false,
        useBuiltIns: 'usage',
        corejs: 3,
        targets: {
          browsers: supportedBrowserVersions
        }
      }], require.resolve('@babel/preset-react')],
      cacheDirectory: true
    }
  };
}